#ifndef ___PIXEL_HPP___
#define ___PIXEL_HPP___

template< typename Pixel >
struct Range
{
	enum
	{
		MAX = 255, MIN = 0
	};
};

#define DEF_RANGE(TYPE,UP,BOTTOM)	\
	template<> struct Range<TYPE>	\
	{								\
		enum						\
		{							\
			MAX = UP, MIN = BOTTOM	\
		};							\
	};

DEF_RANGE( float,	1, 0 )
DEF_RANGE( double,	1, 0 )

#undef DEF_RANGE

template< typename Pixel >
struct Container
{
	typedef Pixel	type;
};

#define DEF_CONTAINER(TYPE,CONT)		\
	template<> struct Container<TYPE>	\
	{									\
		typedef CONT	type;			\
	};

DEF_CONTAINER( unsigned char, int )

#undef DEF_CONTAINER


template< typename T >
inline T round( const T & p )
{
	return std::max( (T) Range<T>::MIN, std::min( (T) Range<T>::MAX, p ) );
}

template< typename T >
inline unsigned char roundUC( const T & p )
{
	return std::max( T(0), std::min( T(255), p ) );
}

#endif
